MARTe2-core - User story #236

Specify C++ version in Linux Makefile
29.09.2015 16:30 - André Neto

Status: Closed Start date: 29.09.2015
Priority: Normal Due date:
Assignee: % Done: 0%
Category: Estimated time: 0.00 hour
Target version: 0.8 Spent time: 0.00 hour
Git branch (link): SVN commit

(link/?p=rev):
Git merge to develop
(link):
Description

Task description

Update the Makefiles to specify the version of C++

Context

MISRA C++:2008 is based on C++03 (ISO/IEC 14882:2003)

For GCC, the option is "-std" with the values c++98, c++03, c++11, and c++14 (see
https://gcc.gnu.org/onlinedocs/gcc/Standards.html#Standards and
https://gcc.gnu.org/onlinedocs/gcc/C-Dialect-Options.html#C-Dialect-Options), while for CL, there is, apparently, no option.

Warning: The srv03 machine has the GCC 4.4.7-16 version installed, which only has the labels c++98 (meaning ANSI C++) and
¢c++0x (which is meant for experimental C++11 features).

Important: Before GCC 5.1 support for C++11 was experimental. Some features were implemented based on early proposals, and
no attempt was made to maintain backward compatibility when they were updated to match the final C++11 standard. [Source:
C++0x/C++11 Support in GCC]

Source code files modified

o MakeDefaults/MakeStdLibDefs.linux

Architecture & design review
Date of the review: 29/09/2015
Person who did the review: André Neto

Version of architecture & design document: N/A. As per the original MARTe implementation, this is a support function and does
not require formal design in UML.

Result of review: N/A

List of non-conformities: N/A

Code and documentation review
Date of the review: 26/11/2015 [a529df5]
Person who did the review: Ivan Herrero

Result of review: PASS
https://gcc.gnu.org/onlinedocs/gcc/Standards.html#Standards
https://gcc.gnu.org/onlinedocs/gcc/C-Dialect-Options.html#C-Dialect-Options
https://gcc.gnu.org/projects/cxx0x.html

List of non-conformities: N/A

Unit test review

Date of the review: 26/11/2015 [a529df5]
Person who did the review: lvan Herrero
Result of coverage tests review: PASS
Result of functional tests review: PASS
Result of review: PASS

List of non-conformities: N/A

Associated revisions

Revision 253812e1 - 25.11.2015 09:34 - Giuseppe Ferro
#236 Added -std=c++11 to the CPPFLAGS in MakeStdLibDefs.linux

Revision a529df53 - 26.11.2015 16:19 - lvan Herrero

#236 - Add -std=c++98 as default option when compiling C++ source files.

History

#1 - 29.09.2015 17:37 - lvan Herrero

- Description updated

#2 - 23.10.2015 13:08 - André Neto

- Subject changed from Specify C++ version in Makefile to Specify C++ version in Linux Makefile

#3 - 23.10.2015 13:18 - André Neto

- Target version changed from 0.6 to 0.7

#4 - 10.11.2015 17:37 - André Neto

- Target version changed from 0.7 to 0.8

#5 - 25.11.2015 09:35 - Giuseppe Ferro
- Description updated

- Status changed from Code: Impl to Code: Rev

#6 - 26.11.2015 16:31 - lvan Herrero
- Description updated

- Status changed from Code: Rev to Closed

First version with -std=c++11 done on 253812e, but reverted on 102813a because c++11 is not accepted by the compiler installed on server (GCC
4.4.7).

Second and final attempt done on a529df5 commit using -std=c++98.
